/*!
 * Snake Game v 1.0
 * http://www.mikusa.com/
 *
 * Copyright 2011, Daniel Mikusa
 * Licensed under the GPL Version 2 license.
 * http://www.mikusa.com/snake/license
 *
 * Date: Sun Jan 30 11:03 2011 -0500
 */
//TODO:
//  - implements levels
//   - different maps
//   - levels change every 10 food eaten

// Globals
var board;
var context;
var game;

jQuery.extend(jQuery.expr[':'], {
	focus: function(element) {
		return element == document.activeElement;
	}
});

function newGame() {
    Snake.setLevel($("#level:checked").val());
    Snake.init();
    game = new Game($("#playerName").val().substring(0, 15));
    game.randomlyPlaceFood();
    game.startGame();
    Frame.clear();
}

function checkForGameSupport() {
    var missing = "";
    if (! Modernizr.canvas) {
        missing += "Canvas, ";
    }
    if (! Modernizr.localstorage) {
        missing += "Local Storage, ";
    }
    if (missing.length > 0) {
        missing = missing.substring(0, missing.length - 2);
        $("#game").html(
        	'<div id="error">' +
				'<img src="images/cartoon_snake.jpg" alt="cartoon snake" />' +
				'<p>Your browser does not support the following HTML5 features which are ' +
				'required to run this game!<span>' + missing + '</span></p>' +
				'<p style="background-color: #FFF">Please install a browser like Firefox ' + 
				'or Chrome which supports these features.<br/><br/>' +
				'<a href="http://www.mozilla.com/?from=sfx&amp;uid=0&amp;t=557"><img ' +
				'src="http://sfx-images.mozilla.org/firefox/3.6/110x32_get_orange.png" ' +
				'alt=Spread Firefox Affiliate Button" border="0" /></a>' + 
				'<a href="http://www.google.com/chrome"><img src="images/chrome_logo.gif"' +
				'border="0" alt="Download Google Chrome"></a>' +
				'</p></div>');
        return false;
    } else {
        return true;
    }
}

$(document).ready(function() {
    if (checkForGameSupport()) {
    	board = $("#board")[0];
    	context = board.getContext("2d");
        // setup new game button
        $("#newGame").click(function() {
            newGame();
        });
        Frame.preGame();
    }
});

function onKeyDown(evt) {
	if (! $("#playerName").is(":focus")) {
		switch(evt.keyCode) {
		   case 37: // left
			   evt.preventDefault();
			   Snake.move(Block.LEFT); break;
		   case 38: // up
			   evt.preventDefault();
			   Snake.move(Block.UP); break;
		   case 39: // right
			   evt.preventDefault();
			   Snake.move(Block.RIGHT); break;
		   case 40: // down
			   evt.preventDefault();
			   Snake.move(Block.DOWN); break;
		   case 67:
			   Game.clearScores();
			   break;
		   case 78: // new game
			   newGame(); break;
		   case 80: // pause
			   game.togglePause();
			   Snake.togglePause();
			   break;
           case 82: // reset scores
               Game.debugScores(); break;
		}
	}
}
$(document).keydown(onKeyDown);

